/*
 * Copyright (C) 2025 ScalAgent Distributed Technologies
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): ScalAgent Distributed Technologies
 * Contributor(s): 
 */
package fr.dyade.aaa.common;

/**
 * Exponential moving average (EMA) is a rule of thumb technique for smoothing time series data
 * using the exponential window function (see https://fr.wikipedia.org/wiki/Moyenne_mobile)
 */
public final class ExponentialMovingAverage {
  private boolean first = true;
  private double alpha;
  private double average;
  
  public synchronized double getAverage() {
    return average;
  }
  
  public synchronized long getLongAverage() {
    return (long) average;
  }
  
  public synchronized int getIntAverage() {
    return (int) average;
  }
  
  public ExponentialMovingAverage(int periods) {
    alpha = 2.0d/(periods+1.0d);
    average = 0;
  }
  
  public synchronized void addValue(double value) {
    if (first) {
      average = value;
      first = false;
    } else {
      average = (alpha*value) + (1.0d-alpha)*average;
    }
  }
}
